Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringArray.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringArray.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringArray.cs	(revision 16171)
@@ -0,0 +1,239 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("StringArray", "Represents an array of strings.")]
+  [StorableClass]
+  public class StringArray : Item, IEnumerable<string>, IStringConvertibleArray {
+    private const int maximumToStringLength = 100;
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+
+    [Storable]
+    protected string[] array;
+
+    [Storable]
+    protected List<string> elementNames;
+    public virtual IEnumerable<string> ElementNames {
+      get { return this.elementNames; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("ElementNames cannot be set. ValueTypeArray is read-only.");
+        if (value == null || !value.Any())
+          elementNames = new List<string>();
+        else if (value.Count() > Length)
+          throw new ArgumentException("The number of element names must not exceed the array length.");
+        else
+          elementNames = new List<string>(value);
+        OnElementNamesChanged();
+      }
+    }
+
+    public virtual int Length {
+      get { return array.Length; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("Length cannot be set. StringArray is read-only.");
+        if (value != Length) {
+          Array.Resize<string>(ref array, value);
+          while (elementNames.Count > value)
+            elementNames.RemoveAt(elementNames.Count - 1);
+          OnElementNamesChanged();
+          OnReset();
+        }
+      }
+    }
+    [Storable]
+    protected bool resizable = true;
+    public bool Resizable {
+      get { return resizable; }
+      set {
+        if (resizable != value) {
+          resizable = value;
+          OnResizableChanged();
+        }
+      }
+    }
+
+    public virtual string this[int index] {
+      get { return array[index]; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("Item cannot be set. StringArray is read-only.");
+        if (value != array[index]) {
+          if ((value != null) || (array[index] != string.Empty)) {
+            array[index] = value != null ? value : string.Empty;
+            OnItemChanged(index);
+          }
+        }
+      }
+    }
+
+    [Storable]
+    protected bool readOnly;
+    public virtual bool ReadOnly {
+      get { return readOnly; }
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      if (elementNames == null) { elementNames = new List<string>(); }
+    }
+
+    [StorableConstructor]
+    protected StringArray(bool deserializing) : base(deserializing) { }
+    protected StringArray(StringArray original, Cloner cloner)
+      : base(original, cloner) {
+      this.array = (string[])original.array.Clone();
+      this.readOnly = original.readOnly;
+      this.resizable = original.resizable;
+      this.elementNames = new List<string>(original.elementNames);
+    }
+    public StringArray() {
+      array = new string[0];
+      readOnly = false;
+      resizable = true;
+      elementNames = new List<string>();
+    }
+    public StringArray(int length) {
+      array = new string[length];
+      for (int i = 0; i < array.Length; i++)
+        array[i] = string.Empty;
+      readOnly = false;
+      resizable = true;
+      elementNames = new List<string>();
+    }
+    public StringArray(string[] elements) {
+      if (elements == null) throw new ArgumentNullException();
+      array = new string[elements.Length];
+      for (int i = 0; i < array.Length; i++)
+        array[i] = elements[i] == null ? string.Empty : elements[i];
+      readOnly = false;
+      resizable = true;
+      elementNames = new List<string>();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StringArray(this, cloner);
+    }
+
+    public virtual StringArray AsReadOnly() {
+      StringArray readOnlyStringArray = (StringArray)this.Clone();
+      readOnlyStringArray.readOnly = true;
+      return readOnlyStringArray;
+    }
+    IValueTypeArray IValueTypeArray.AsReadOnly() {
+      return AsReadOnly();
+    }
+
+    public override string ToString() {
+      if (array.Length == 0) return "[]";
+
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[");
+      sb.Append(array[0]);
+      for (int i = 1; i < array.Length; i++) {
+        sb.Append(";").Append(array[i]);
+        if (sb.Length > maximumToStringLength) {
+          sb.Append("...");
+          break;
+        }
+      }
+      sb.Append("]");
+      return sb.ToString();
+    }
+
+    public virtual IEnumerator<string> GetEnumerator() {
+      return array.Cast<string>().GetEnumerator();
+    }
+    IEnumerator IEnumerable.GetEnumerator() {
+      return GetEnumerator();
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      if (value == null) {
+        errorMessage = "Invalid Value (string must not be null)";
+        return false;
+      } else {
+        errorMessage = string.Empty;
+        return true;
+      }
+    }
+    protected virtual string GetValue(int index) {
+      return this[index];
+    }
+    protected virtual bool SetValue(string value, int index) {
+      if (value != null) {
+        this[index] = value;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    public event EventHandler ResizableChanged;
+    protected virtual void OnResizableChanged() {
+      EventHandler handler = ResizableChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ElementNamesChanged;
+    protected virtual void OnElementNamesChanged() {
+      EventHandler handler = ElementNamesChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler<EventArgs<int>> ItemChanged;
+    protected virtual void OnItemChanged(int index) {
+      if (ItemChanged != null)
+        ItemChanged(this, new EventArgs<int>(index));
+      if (index < maximumToStringLength)
+        OnToStringChanged();
+    }
+    public event EventHandler Reset;
+    protected virtual void OnReset() {
+      if (Reset != null)
+        Reset(this, EventArgs.Empty);
+      OnToStringChanged();
+    }
+
+    #region IStringConvertibleArray Members
+    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleArray.GetValue(int index) {
+      return GetValue(index);
+    }
+    bool IStringConvertibleArray.SetValue(string value, int index) {
+      return SetValue(value, index);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringConvertibleArray.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringConvertibleArray.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringConvertibleArray.cs	(revision 16171)
@@ -0,0 +1,57 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("StringConvertibleArray", "Represents an array of string convertible values.")]
+  [StorableClass]
+  public abstract class StringConvertibleArray<T> : ValueTypeArray<T>, IStringConvertibleArray where T : struct {
+    [StorableConstructor]
+    protected StringConvertibleArray(bool deserializing) : base(deserializing) { }
+    protected StringConvertibleArray(StringConvertibleArray<T> original, Cloner cloner)
+      : base(original, cloner) { }
+
+    protected StringConvertibleArray() : base() { }
+    protected StringConvertibleArray(int length) : base(length) { }
+    protected StringConvertibleArray(T[] elements) : base(elements) { }
+
+    protected abstract bool Validate(string value, out string errorMessage);
+    protected abstract string GetValue(int index);
+    protected abstract bool SetValue(string value, int index);
+
+    #region IStringConvertibleArray Members
+    bool IStringConvertibleArray.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleArray.GetValue(int index) {
+      return GetValue(index);
+    }
+    bool IStringConvertibleArray.SetValue(string value, int index) {
+      return SetValue(value, index);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringConvertibleValueTuple.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringConvertibleValueTuple.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringConvertibleValueTuple.cs	(revision 16171)
@@ -0,0 +1,99 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [StorableClass]
+  [Item("StringConvertibleValueTuple<,>", "A generic abstract base class for representing multiple values of a string convertible value.")]
+  public abstract class StringConvertibleValueTuple<T, U> : Item, IStringConvertibleValueTuple
+    where T : class, IDeepCloneable, IStringConvertibleValue
+    where U : class, IDeepCloneable, IStringConvertibleValue {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.ValueType; }
+    }
+
+    [Storable]
+    protected bool readOnly;
+    public virtual bool ReadOnly {
+      get { return readOnly; }
+    }
+
+    [Storable(Name = "Values")]
+    protected Tuple<T, U> values;
+
+    protected T Item1 { get { return values.Item1; } }
+    IStringConvertibleValue IStringConvertibleValueTuple.Item1 { get { return Item1; } }
+    protected U Item2 { get { return values.Item2; } }
+    IStringConvertibleValue IStringConvertibleValueTuple.Item2 { get { return Item2; } }
+
+    [StorableConstructor]
+    protected StringConvertibleValueTuple(bool deserializing)
+      : base(deserializing) {
+    }
+    protected StringConvertibleValueTuple(StringConvertibleValueTuple<T, U> original, Cloner cloner)
+      : base(original, cloner) {
+      T item1 = (T)cloner.Clone(original.values.Item1);
+      U item2 = (U)cloner.Clone(original.values.Item2);
+      values = Tuple.Create<T, U>(item1, item2);
+      RegisterEventHandler();
+    }
+
+    public StringConvertibleValueTuple(T item1, U item2)
+      : base() {
+      values = Tuple.Create<T, U>(item1, item2);
+      readOnly = false;
+      RegisterEventHandler();
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      RegisterEventHandler();
+    }
+
+
+    public abstract StringConvertibleValueTuple<T, U> AsReadOnly();
+
+    public override string ToString() {
+      return string.Format("Item1: {0}, Item2: {1}", Item1, Item2);
+    }
+
+    private void RegisterEventHandler() {
+      Item1.ValueChanged += Item_ValueChanged;
+      Item2.ValueChanged += Item_ValueChanged;
+    }
+
+    private void Item_ValueChanged(object sender, EventArgs e) {
+      OnValueChanged();
+    }
+
+    public event EventHandler ValueChanged;
+    protected virtual void OnValueChanged() {
+      if (ValueChanged != null)
+        ValueChanged(this, EventArgs.Empty);
+      OnToStringChanged();
+    }
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringMatrix.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringMatrix.cs	(revision 16171)
@@ -0,0 +1,330 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("StringMatrix", "Represents a matrix of strings.")]
+  [StorableClass]
+  public class StringMatrix : Item, IEnumerable<string>, IStringConvertibleMatrix {
+    private const int maximumToStringLength = 100;
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+
+    [Storable]
+    protected string[,] matrix;
+
+    [Storable]
+    protected List<string> columnNames;
+    public virtual IEnumerable<string> ColumnNames {
+      get { return this.columnNames; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("ColumnNames cannot be set. StringMatrix is read-only.");
+        if (value == null || value.Count() == 0)
+          columnNames = new List<string>();
+        else if (value.Count() != Columns)
+          throw new ArgumentException("A column name must be specified for each column .");
+        else
+          columnNames = new List<string>(value);
+        OnColumnNamesChanged();
+      }
+    }
+    [Storable]
+    protected List<string> rowNames;
+    public virtual IEnumerable<string> RowNames {
+      get { return this.rowNames; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("RowNames cannot be set. StringMatrix is read-only.");
+        if (value == null || value.Count() == 0)
+          rowNames = new List<string>();
+        else if (value.Count() != Rows)
+          throw new ArgumentException("A row name must be specified for each row.");
+        else
+          rowNames = new List<string>(value);
+        OnRowNamesChanged();
+      }
+    }
+    [Storable]
+    protected bool sortableView;
+    public virtual bool SortableView {
+      get { return sortableView; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("SortableView cannot be set. StringMatrix is read-only.");
+        if (value != sortableView) {
+          sortableView = value;
+          OnSortableViewChanged();
+        }
+      }
+    }
+
+    public virtual int Rows {
+      get { return matrix.GetLength(0); }
+      protected set {
+        if (ReadOnly) throw new NotSupportedException("Rows cannot be set. StringMatrix is read-only.");
+        if (value != Rows) {
+          string[,] newMatrix = new string[value, Columns];
+          Array.Copy(matrix, newMatrix, Math.Min(value * Columns, matrix.Length));
+          matrix = newMatrix;
+          while (rowNames.Count > value)
+            rowNames.RemoveAt(rowNames.Count - 1);
+          while (rowNames.Count < value)
+            rowNames.Add("Row " + rowNames.Count);
+          OnRowsChanged();
+          OnRowNamesChanged();
+          OnReset();
+        }
+      }
+    }
+    public virtual int Columns {
+      get { return matrix.GetLength(1); }
+      protected set {
+        if (ReadOnly) throw new NotSupportedException("Columns cannot be set. StringMatrix is read-only.");
+        if (value != Columns) {
+          string[,] newMatrix = new string[Rows, value];
+          for (int i = 0; i < Rows; i++)
+            Array.Copy(matrix, i * Columns, newMatrix, i * value, Math.Min(value, Columns));
+          matrix = newMatrix;
+          while (columnNames.Count > value)
+            columnNames.RemoveAt(columnNames.Count - 1);
+          while (columnNames.Count < value)
+            columnNames.Add("Column " + columnNames.Count);
+          OnColumnsChanged();
+          OnColumnNamesChanged();
+          OnReset();
+        }
+      }
+    }
+    public virtual string this[int rowIndex, int columnIndex] {
+      get { return matrix[rowIndex, columnIndex]; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("Item cannot be set. StringMatrix is read-only.");
+        if (value != matrix[rowIndex, columnIndex]) {
+          if ((value != null) || (matrix[rowIndex, columnIndex] != string.Empty)) {
+            matrix[rowIndex, columnIndex] = value != null ? value : string.Empty;
+            OnItemChanged(rowIndex, columnIndex);
+          }
+        }
+      }
+    }
+
+    [Storable]
+    protected bool readOnly;
+    public virtual bool ReadOnly {
+      get { return readOnly; }
+    }
+
+    [StorableConstructor]
+    protected StringMatrix(bool deserializing) : base(deserializing) { }
+    protected StringMatrix(StringMatrix original, Cloner cloner)
+      : base(original, cloner) {
+      this.matrix = (string[,])original.matrix.Clone();
+      this.columnNames = new List<string>(original.columnNames);
+      this.rowNames = new List<string>(original.rowNames);
+      this.sortableView = original.sortableView;
+      this.readOnly = original.readOnly;
+    }
+    public StringMatrix() {
+      matrix = new string[0, 0];
+      columnNames = new List<string>();
+      rowNames = new List<string>();
+      sortableView = false;
+      readOnly = false;
+    }
+    public StringMatrix(int rows, int columns) {
+      matrix = new string[rows, columns];
+      for (int i = 0; i < matrix.GetLength(0); i++) {
+        for (int j = 0; j < matrix.GetLength(1); j++)
+          matrix[i, j] = string.Empty;
+      }
+      columnNames = new List<string>();
+      rowNames = new List<string>();
+      sortableView = false;
+      readOnly = false;
+    }
+    protected StringMatrix(int rows, int columns, IEnumerable<string> columnNames)
+      : this(rows, columns) {
+      ColumnNames = columnNames;
+    }
+    protected StringMatrix(int rows, int columns, IEnumerable<string> columnNames, IEnumerable<string> rowNames)
+      : this(rows, columns, columnNames) {
+      RowNames = rowNames;
+    }
+    public StringMatrix(string[,] elements) {
+      if (elements == null) throw new ArgumentNullException();
+      matrix = new string[elements.GetLength(0), elements.GetLength(1)];
+      for (int i = 0; i < matrix.GetLength(0); i++) {
+        for (int j = 0; j < matrix.GetLength(1); j++)
+          matrix[i, j] = elements[i, j] == null ? string.Empty : elements[i, j];
+      }
+      columnNames = new List<string>();
+      rowNames = new List<string>();
+      sortableView = false;
+      readOnly = false;
+    }
+    protected StringMatrix(string[,] elements, IEnumerable<string> columnNames)
+      : this(elements) {
+      ColumnNames = columnNames;
+    }
+    protected StringMatrix(string[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames)
+      : this(elements, columnNames) {
+      RowNames = rowNames;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StringMatrix(this, cloner);
+    }
+
+    public virtual StringMatrix AsReadOnly() {
+      StringMatrix readOnlyStringMatrix = (StringMatrix)this.Clone();
+      readOnlyStringMatrix.readOnly = true;
+      return readOnlyStringMatrix;
+    }
+
+    public override string ToString() {
+      if (matrix.Length == 0) return "[]";
+
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[");
+      for (int i = 0; i < Rows; i++) {
+        sb.Append("[").Append(matrix[i, 0]);
+        for (int j = 1; j < Columns; j++)
+          sb.Append(";").Append(matrix[i, j]);
+        sb.Append("]");
+
+        if (sb.Length > maximumToStringLength) {
+          sb.Append("[...]");
+          break;
+        }
+      }
+      sb.Append("]");
+
+      return sb.ToString();
+    }
+
+    public virtual IEnumerator<string> GetEnumerator() {
+      return matrix.Cast<string>().GetEnumerator();
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return GetEnumerator();
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      if (value == null) {
+        errorMessage = "Invalid Value (string must not be null)";
+        return false;
+      } else {
+        errorMessage = string.Empty;
+        return true;
+      }
+    }
+    protected virtual string GetValue(int rowIndex, int columIndex) {
+      return this[rowIndex, columIndex];
+    }
+    protected virtual bool SetValue(string value, int rowIndex, int columnIndex) {
+      if (value != null) {
+        this[rowIndex, columnIndex] = value;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    #region events
+    public event EventHandler ColumnsChanged;
+    protected virtual void OnColumnsChanged() {
+      EventHandler handler = ColumnsChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler RowsChanged;
+    protected virtual void OnRowsChanged() {
+      EventHandler handler = RowsChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ColumnNamesChanged;
+    protected virtual void OnColumnNamesChanged() {
+      EventHandler handler = ColumnNamesChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler RowNamesChanged;
+    protected virtual void OnRowNamesChanged() {
+      EventHandler handler = RowNamesChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler SortableViewChanged;
+    protected virtual void OnSortableViewChanged() {
+      EventHandler handler = SortableViewChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler<EventArgs<int, int>> ItemChanged;
+    protected virtual void OnItemChanged(int rowIndex, int columnIndex) {
+      if (ItemChanged != null)
+        ItemChanged(this, new EventArgs<int, int>(rowIndex, columnIndex));
+
+      //approximation to avoid firing of unnecessary ToStringChangedEvents
+      //columnIndex is not used, because always full rows are returned in the ToString method
+      if (rowIndex * Columns < maximumToStringLength)
+        OnToStringChanged();
+    }
+    public event EventHandler Reset;
+    protected virtual void OnReset() {
+      if (Reset != null)
+        Reset(this, EventArgs.Empty);
+      OnToStringChanged();
+    }
+    #endregion
+
+    #region IStringConvertibleMatrix Members
+    int IStringConvertibleMatrix.Rows {
+      get { return Rows; }
+      set { Rows = value; }
+    }
+    int IStringConvertibleMatrix.Columns {
+      get { return Columns; }
+      set { Columns = value; }
+    }
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleMatrix.GetValue(int rowIndex, int columIndex) {
+      return GetValue(rowIndex, columIndex);
+    }
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+      return SetValue(value, rowIndex, columnIndex);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringValue.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringValue.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/StringValue.cs	(revision 16171)
@@ -0,0 +1,135 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("StringValue", "Represents a string.")]
+  [StorableClass]
+  public class StringValue : Item, IComparable, IStringConvertibleValue {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
+    }
+
+    [Storable]
+    protected string value;
+    public virtual string Value {
+      get { return value; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("Value cannot be set. StringValue is read-only.");
+        if (value != this.value) {
+          if ((value != null) || (this.value != string.Empty)) {
+            this.value = value != null ? value : string.Empty;
+            OnValueChanged();
+          }
+        }
+      }
+    }
+
+    [Storable]
+    protected bool readOnly;
+    public virtual bool ReadOnly {
+      get { return readOnly; }
+    }
+
+    [StorableConstructor]
+    protected StringValue(bool deserializing) : base(deserializing) { }
+    protected StringValue(StringValue original, Cloner cloner)
+      : base(original, cloner) {
+      this.value = original.value != null ? original.value : string.Empty;
+      this.readOnly = original.readOnly;
+    }
+    public StringValue() {
+      this.value = string.Empty;
+      this.readOnly = false;
+    }
+    public StringValue(string value) {
+      this.value = value != null ? value : string.Empty;
+      this.readOnly = false;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new StringValue(this, cloner);
+    }
+
+    public virtual StringValue AsReadOnly() {
+      StringValue readOnlyStringValue = (StringValue)this.Clone();
+      readOnlyStringValue.readOnly = true;
+      return readOnlyStringValue;
+    }
+
+    public override string ToString() {
+      return value;
+    }
+
+    public virtual int CompareTo(object obj) {
+      StringValue other = obj as StringValue;
+      if (other != null)
+        return Value.CompareTo(other.Value);
+      else
+        return Value.CompareTo(obj);
+    }
+
+    public event EventHandler ValueChanged;
+    protected virtual void OnValueChanged() {
+      if (ValueChanged != null)
+        ValueChanged(this, EventArgs.Empty);
+      OnToStringChanged();
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      if (value == null) {
+        errorMessage = "Invalid Value (string must not be null)";
+        return false;
+      } else {
+        errorMessage = string.Empty;
+        return true;
+      }
+    }
+    protected virtual string GetValue() {
+      return Value;
+    }
+    protected virtual bool SetValue(string value) {
+      if (value != null) {
+        Value = value;
+        return true;
+      } else {
+        return false;
+      }
+    }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
+    #endregion
+  }
+}
